<?php

//  Copyright (c) 2008-2012 Karelia Software. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  *  Redistribution of source code must retain the above copyright notice,
//     this list of conditions and the follow disclaimer.
//
//  *  Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other material provided with the distribution.
//
//  *  Neither the name of Karelia Software nor the names of its contributors
//     may be used to endorse or promote products derived from this software
//     without specific prior written permission.
//
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS-IS"
//  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
//  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
//  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
//  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
//  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
//  ARISING IN ANY WAY OUR OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
//  POSSIBILITY OF SUCH DAMAGE.
//

include_once('mailme.password.php');	// Or you can just define the value of $key here.
										// It should be same as user default value of mailmePassword

include_once('mailme.strings.php');

require_once('phpmailer/class.phpmailer.php');

// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 
// FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS FUNCTIONS 

function extract_emails_from($string){
    preg_match_all("/[\._a-zA-Z0-9-]+@[\._a-zA-Z0-9-]+/i", $string, $matches);
    return $matches[0];
}

function containsNewlines($str_to_test) {
	return (preg_match("/(%0A|%0D|\\n+|\\r+)/i", $str_to_test) != 0);
}

// from http://www.phpbuilder.com/columns/ian_gilfillan20060412.php3?page=2
function exit_if_newlines($str_to_test) {
   if(preg_match("/(%0A|%0D|\\n+|\\r+)/i", $str_to_test) != 0) {
     exit;
   }
}

function decodeRecipient($v, $alg)
{
	global $key;
	$cryptAndCRC = explode('.', $v);	// we only need first part before dot; not using CRC anymore

	// Decrypt
	if ($alg == MCRYPT_3DES)
	{
		$td = mcrypt_module_open(MCRYPT_3DES, '', MCRYPT_MODE_CBC, '');
	}
	else if ($alg == MCRYPT_DES)
	{
		$td = mcrypt_module_open(MCRYPT_DES, '', MCRYPT_MODE_CBC, '');
		// Note that DES needs a shorter key
	}
	else
	{
		$td = mcrypt_module_open('blowfish', '', 'ncfb', '');
	}
	$iv = "\0\0\0\0\0\0\0\0";
	mcrypt_generic_init($td, $key, $iv);
	$recipient = mdecrypt_generic($td, base64_decode($cryptAndCRC[0]));
	$recipient = rtrim($recipient);
	mcrypt_generic_deinit($td);
	mcrypt_module_close($td);

	if (empty($recipient))
	{
		$recipient = nil;
	}
	return $recipient;
}

function trimFirst($string)	// gets the first line of a multi-line input and trims it. Really cleans the input!
{
	$lines = explode("\n",$string);
	$string = $lines[0];
	$string = trim($string);
	return $string;
}

function testStringAsBoolean($string)
{
	$result = TRUE;
	$string = strtolower($string);
	if (empty($string)
		|| $string == 'no'
		|| $string == '0'
   		|| $string == 'false'
		|| $string == 'f'
		|| $string == 'n'
	    )
	{
		$result = FALSE;
	}
	return $result;
}

// POST FUNCTIONS.  Use postraw for a textarea.
function postraw($key, $default='')
{
	return isset ( $_POST[$key] ) ? $_POST[$key] : $default;
}
function post($key, $default='')
{
	return isset ( $_POST[$key] ) ? trimFirst($_POST[$key]) : $default;
}
function isPost($key)
{
	return isset ( $_POST[$key] ) ? testStringAsBoolean($_POST[$key]) : FALSE;
}

// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 
// PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS PREFLIGHT CHECKS 

if ( 0 == strcmp('GET',$_SERVER['REQUEST_METHOD'])  )
{
    // For some reason, this doesn't really do anything!  Oh well.
    header("HTTP/1.1 405 Method Not Allowed");

	echo "You should be accessing this via POST not GET.\n\n\n";
	die();
}

if (!isPost('v') && !isPost('vv')  && !isPost('v1'))
{
	echo "Missing V parameter. Please contact Karelia Support if you feel this is in error.\n\n\n";
	die;
}

// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 
// GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS GET INPUTS 

// USED FORM ELEMENTS A CDEF H   LMN  QRST V XYZ

$devMode	= isPost('devm');	// secret developer mode -- if set we can issue warnings and so forth

if ($devMode)
{
	print_r($_POST);
	echo "\n\n\n";
	print_r($_SERVER);
}

$fromEmail	= post('e', '');	// from email
$name		= post('n', '');	// from name
$subject	= post('s', '');	// subject
$message	= postraw('m', '');	// message .... textarea

$message = str_replace("\r\n", "\n", $message);		// try to get rid of \r's
$message = str_replace("\r", "\n", $message);

$siteTitle	= post('t', '');	// title of site to return to

$v = '';

// key of 'v' is old-style blowfish
// key of 'vv' is newer 3DES
// key of 'v1' is newest DES (which we are using now to make one less strong-encryption issue to report)

if (isPost('v'))
{
    $v			= post('v', '');	// encrypted destination email(s)
	$alg = 'blowfish';

}
else if (isPost('vv'))
{
    $v			= post('vv', '');	// encrypted destination email(s)
	$alg = MCRYPT_3DES;
}
else if (isPost('v1'))
{
    $v			= post('v1', '');	// encrypted destination email(s)
	$alg = MCRYPT_DES;
}

if (empty($v))
{
	echo "Empty V parameter. Please contact Karelia Support if you feel this is in error.\n\n\n";
	die;
}

$fromEmails = extract_emails_from($fromEmail);

$design		= post('d', '');	// design [OBSOLETE, pre 1.1]
$cssURL		= post('a', '');	// URL of CSS to use for landing page [1.1+]
																	// Also: 'x' is the name of the 'Send' button

$honeypot1		= post('subject', '');
$honeypot2		= post('message', '');

$hasHoneypot = isset($_POST['subject']);

// EXTRA GOODIES, NOT IN THE SANDVOX UI:

$successReturn = post('r', '');	// where to return.  Referer will be used if not specified.

// NOTE: WE NEED TO EXTRACT \t \n BEFORE CALLING STRIPSLASHES.

$footer		= post('f', '');	// footer text, appended below main text
$footer		= str_replace('\t', "\t", $footer);
$footer		= str_replace('\n', "\n", $footer);

$ccSender	= isPost('c');									// should sender be CC'd? [WARNING: SENDER WILL SEE YOUR ADDRESS]

$delim		= post('l', ': ');	// delimeter (with \t \n OK)
$delim		= str_replace('\t', "\t", $delim);
$delim		= str_replace('\n', "\n", $delim);

$prefix		= post('y', '');	// subject prefix
$suffix		= post('z', '');	// subject suffix

$errorReturn = post('q', '');	// URL to return to (after landing page) if there was an error

// hack -- for some reason, sometimes there is a "+" in the encrypted email that is decoded as ' ' so let' try switching it back
$v = str_replace(' ','+',$v);

$recipient= decodeRecipient($v, $alg);

if (empty($recipient))
{
	echo "Unable to decode recipient. Please contact Karelia Support if you feel this is in error.\n\n\n";
	die;
}

$recipEmails = extract_emails_from($recipient);

$errorString = '';		// if we put a message here, it will show on the result page.

$givenCRC = (float)$cryptAndCRC[1];
$myCRC = (float)crc32($recipient);

// Look for extra POST parameters and insert them into the message.
$fields = '';

foreach($_POST as $postKey => $postValue)
{
	if (strlen($postKey) > 1 && $postKey != 'subject' && $postKey != 'message' && $postKey != 'v' && $postKey != 'vv' && $postKey != 'v1')	// ignore 1-char keys and honeypots
	{
		$fields .= "$postKey$delim$postValue\n";		// e.g. key tab value
	}
}
if (!empty($fields)) {
	$message = $fields . "\n" . $message;
}

if (!$hasHoneypot )
{
	$message .=  "\n\n\n\nAutomated notice from Karelia Software:\n\nYou are receiving this message from a contact form relay installed\nby an older version of Sandvox. In June 2007, we updated our contact\nforms to be far less susceptible to spam. Please download the latest\nversion of Sandvox from http://www.karelia.com/ and re-publish your\nwebsite, to take advantage of our anti-spam measures.\n\n";
}

if (!empty($footer)) {
	$message .= "\n\n$footer";
}

if ( !isset($_SERVER['HTTP_REFERER']) &&  !isset($_SERVER['HTTP________']) && !isset($_SERVER['HTTP________________']) && !strstr($_SERVER['HTTP_USER_AGENT'], 'Sandvox') )
{
// allow for HTTP________ instead of referer -- this is apparently a symantec firewall.

	// error_log(date("c")." Referer missing from mailme.php request, REMOTE_ADDR = ".$_SERVER['REMOTE_ADDR']." from ". $fromEmail ." to ". $recipient,1,BACKEND_ERROR_NOTIFICATION_EMAIL);
}

if ( empty($fromEmail) || 0 == count($fromEmails) )
{
	$errorString = $MISSING_SENDER;
}
else if ( empty($subject) && empty($message) )
{
	$errorString = $MISSING_MESSAGE;
}
else if ( (2 == count($cryptAndCRC)) && ((float)$cryptAndCRC[1] != (float)crc32($recipient)) )
{
	$errorString = str_replace('%@', $siteTitle, $BAD_DESTINATION_FORMAT);
}
else if (!empty($honeypot1) || !empty($honeypot2))
{
	// use same error message of the 'verification code'
	$errorString = str_replace('%@', $siteTitle, $BAD_DESTINATION_FORMAT);
}
else if (0 == count($recipEmails))
{
	$errorString = $MISSING_DESTINATION;
}
else		// Everything looks OK, proceed
{
	$referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
	$referer = str_replace("\n", ' ', $referer);
	$referer = str_replace("\r", ' ', $referer);
	if (0 === strpos($referer, '----'))
	{
		$referer = '';		// somehow referer is being sent as -------------------------------------------------  -- case 40266
	}

	if (empty($subject))
	{
		$subject = $FALLBACK_SUBJECT;
	}
	if (!empty($prefix))
	{
		$subject = "$prefix $subject";
	}
	if (!empty($suffix))
	{
		$subject = "$subject $suffix";
	}
	if (empty($name))
	{
		$emailOrName = $fromEmails[0];;
	}
	else
	{
		$emailOrName = $name;
	}

	$mail = new PHPMailer();

	$mail->SetLanguage("en", "phpmailer/language/");
	$mail->Mailer = 'sendmail';		// default must have been mail.  It was having problems with blank lines between headers....
	if ($mail->Mailer == 'smtp')
	{
		$mail->SMTPSecure = SMTPSECURE;
		$mail->Host		= MAILHOST; // SMTP server
		$mail->SMTPAuth = SMTPAUTH;     // turn on SMTP authentication 
		$mail->Username = SMTPUSERNAME; 
		$mail->Password = SMTPPASSWORD;
		$mail->Hostname = SMTPHOSTNAME;
		$mail->Sender	= SENDER;	// for bouncies
	}
	
	$mail->WordWrap = 76;
	$mail->CharSet = "utf-8";
	$mail->IsHTML(false);
	$mail->Subject = $subject;
	$mail->Body = $message;

	$mail->AddCustomHeader("X-Mailer: Form relay for Sandvox. If you suspect abuse, contact us: http://www.karelia.com/contact_us.html");
        $mail->AddCustomHeader("X-Note: Please note that although our contact form uses anti-spam honeypot techniques, a few spam submissions occasionally sneak through.");

	$mail->AddCustomHeader("X-Remote-Addr: " . $_SERVER['REMOTE_ADDR']);
	if (!empty($referer))
	{
		$mail->AddCustomHeader("X-referer: $referer");
	}
	if (!empty($cssURL))
	{
		$mail->AddCustomHeader("X-CSS-URL: $cssURL");
	}
	if (!empty($siteTitle))
	{
		$mail->AddCustomHeader("X-Site-Title: $siteTitle");
	}
	if (!empty($successReturn))
	{
		$mail->AddCustomHeader("X-Return-URL: $successReturn");
	}
	if (	containsNewlines($recipient)
		||	containsNewlines($subject)
		||	containsNewlines($fromEmail)
		||	containsNewlines($name) )
	{
		echo "newline found. Suspected injection attempt - mail not being sent.";
		exit;
	}

	$mail->Sender = $fromEmails[0];	// for return-path header

	if (!empty($name))
	{
		$fromName = $name;
	}
	else
	{
		$fromName = $fromEmails[0];
	}
	$mail->FromName = $fromName;

	$mail->From = $fromEmails[0];
	$mail->AddReplyTo($fromEmails[0], $fromName);

	if ($ccSender)	// Send a copy to the sender, so make them seem like the recipient, and BCC the actual recipient.
	{
		$mail->AddAddress($fromEmails[0]);
		foreach($recipEmails as $oneEmail)
		{
			$mail->AddBCC($oneEmail,$oneEmail);
		}
	}
	else	// normal sending, recipient is normal "To:" because it's only sent to you
	{
		foreach($recipEmails as $oneEmail)
		{
			$mail->AddAddress($oneEmail,$oneEmail);
		}
	}

	$mailSent = $mail->Send();
	if (!$mailSent)
	{
		if (strpos($mail->ErrorInfo, '@') === false)
		{
			$errorString = str_replace('%@', $mail->ErrorInfo, $UNABLE_TO_SEND_FORMAT);
		}
		else
		{
			$errorString = $UNABLE_TO_SEND;		// don't show the email in the message
		}
		error_log("mailme.php: mail not sent with SMTP (will try sendmail)... " . $mail->ErrorInfo, 1, BACKEND_ERROR_NOTIFICATION_EMAIL);

		$mail->Mailer = 'sendmail';	// try again with sendmail
		$mailSent = $mail->Send();
	}
	if (!$mailSent)
	{
		if (strpos($mail->ErrorInfo, '@') === false)
		{
			$errorString = str_replace('%@', $mail->ErrorInfo, $UNABLE_TO_SEND_FORMAT);
		}
		else
		{
			$errorString = $UNABLE_TO_SEND;		// don't show the email in the message
		}
		error_log("mailme.php: mail not sent... " . $mail->ErrorInfo, 1, BACKEND_ERROR_NOTIFICATION_EMAIL);
	}
}

if (empty($successReturn) || !empty($errorString))		// do we need to go to an intermediate page?  (error or specified return page)
{
	$redirectSite = "/mailsent.html";
	$redirectSite .= "?t=" . urlencode($siteTitle);

	$successReturn = $referer;		// if we didn't specify return site, use referer -- unless we have an error return site (below)
	if (!empty($errorString))		// was there an error?
	{
		$redirectSite .= "&e=" . urlencode($errorString);

		if (!empty($errorReturn))		// did we specify an error site?  If so, we'll go there instead.
		{
			$successReturn = $errorReturn;	// use errorReturn instead of successReturn
		}
	}
	$redirectSite .= "&r=" . urlencode($successReturn);

	if (!empty($design))
	{
		$redirectSite .= "&d=" . urlencode($design);
	}
	if (!empty($cssURL))
	{
		$redirectSite .= "&a=" . urlencode($cssURL);
	}
}
else		// non-empty success return; we'll be going there!
{
	$redirectSite = $successReturn;		// we have specified a specific return site on success; go there
}
header("Location: $redirectSite");

?>
